% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR
% P9_1: Proiectarea unui FTJ cu metoda Pade

% Calculul coeficientilor b_k ai numaratorului
x=[1 1];
y=conv(x,x);
b=0.0048*conv(y,y);

% Calculul coeficientilor a_k ai numitorului
a=conv([1 -1.0486 0.2962],[1 -1.321 0.6328]);

% Calculul functiei de transfer a filtrului dorit (din coef. b_k si a_k)
[h,w]=freqz(b,a);

% Calculul primelor 21 de esantioane ale raspunsului la impuls dorit, h_d
hd=impz(b,a,21);

% Ordinul filtrului proiectat (M = gradul numaratorului, N = gradul numitorului)
M=3;
N=5;

% Metoda Pade
[b1,a1]=pademethod(hd,M,N);

% Functia de transfer a filtrului obtinut
[h1,w1]=freqz(b1,a1);

% Afisare - functiile de transfer
figure(1);
plot(w/pi,20*log10(abs(h)),w1/pi,20*log10(abs(h1)),'r');
legend('Raspunsul filtrului initial','Raspunsul filtrului sintetizat');
axis([0 1 -70 20]);

% Afisare - raspunsurile la impuls
h2 = impz(b1, a1, 21);
figure(2);
plot(0:20,hd,0:20,h2,'r');
legend('Raspunsul la impuls al filtrului initial','Raspunsul la impuls al filtrului sintetizat');

