% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR
% P9_2: Proiectarea unui FTJ cu metoda celor mai mici patrate

% Lungimea considerata a raspunsului la impuls
L=21;

% Ordinul filtrului dorit
N=4;

% Calculul coeficientiloe b_k
x=[1 1];y=conv(x,x);
b=0.0048*conv(y,y);

% Calculul coeficientilor a_k
a=conv([1 -1.0486 0.2962],[1 -1.321 0.6328]);

% Calculul functiei de transfer a filtrului dorit (din coef. b_k si a_k)
[h,w]=freqz(b,a);

% Calculul primelor L de esantioane ale raspunsului la impuls dorit, h_d
hd=impz(b,a,L);

% Metoda celor mai mici patrate
a1=lsinv(hd,N);

% Afisare - functiile de transfer
figure(1);
[h1,w1]=freqz(hd(1),a1); % b_0 = hd[0]
plot(w/pi,20*log10(abs(h)),w1/pi,20*log10(abs(h1)),'r');
legend('Raspunsul filtrului initial','Raspunsul filtrului sintetizat');
axis([0 1 -70 20]);

% Afisare - raspunsurile la impuls
h2 = impz(hd(1), a1, L);
figure(2);
plot(0:(L-1),hd,0:(L-1),h2,'r');
legend('Raspunsul la impuls al filtrului initial','Raspunsul la impuls al filtrului sintetizat');
