% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR

function a = lsinv(hd,N)
% Proiectarea unui filtru numai cu poli prin metoda celor mai mici patrate
% Parametrii:
%  hd = raspunsul la impuls dorit
%  N = gradul numitorului
% Iesire:
%  a = coeficientii numitorului

% Make hd a column vector
[m,n] = size(hd);
if m == 1
    hd = hd';
end

% Calcul vector rdd si restrangere la valorile rdd(1:N)
rdd = xcorr(hd);
L = length(hd);
r = -rdd(L+1:L+N);

% Calcul matrice Rdd
row = rdd(L:L+N-1);
R = toeplitz(row);

% Rezolvarea sistemului
a = inv(R)*r;
a = [1; a];
