% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR

function [b,a]=pademethod(h,M,N)
% Proiectarea unui filtru prin metoda Pade
% Parametrii:
%  h = raspunsul la impuls dorit
%  M = gradul numaratorului
%  N = gradul numitorului
% Iesire:
%  b = coeficientii numaratorului
%  a = coeficientii numitorului

if length(h)<M+N+1
   disp('lungimea raspunsului la impuls este mai mica decit');
   disp(M+N-1);
   error('Cresteti lungimea raspunsului la impuls');
end;

% Make h a row vector
if (size(h,1) > size(h,2))
    h = h';
end

% Make H matrix
H = zeros(M+N+1, N);
for i = 1:(M+N+1)
    if i <= N
        H(i,:) = [h(i-1:-1:1)  zeros(1, N+1-i)];
    else
        H(i,:) = h(i-1:-1:i-N);
    end
end

% Solve for a_k's
a = inv(-H(M+2:end, :)) * h(M+2:M+N+1)';
b = h(1:M+1)' + H(1:M+1, :) * a;

a = [1; a];


         
      
         