% Laborator PSS: Tehnici directe de proiectare a filtrelor IIR
% P9_0: Proiectarea unui filtru opreste-banda IIR prin metoda Yule-Walker

% Vector cu frecvente (intre 0 si 1)
f=[0 0.3 0.4 0.7  0.8 1];

% Vector cu magnitudinile dorite la frecventele din f
m=[1 1  0.01 0.01 0.5 0.5];

% Metoda Yule-Walker
[b,a]=yulewalk(10,f,m);

% Calculul functiei de transfer h din numaratorul b si numitorul
[h,w]=freqz(b,a);

% Afisare
plot(w/pi,abs(h));
ylabel('Amplitudine');xlabel('\omega/\pi')
